# Brno je magické

Hra probíhá na šestiúhelníkovém plánu. Každé políčko představuje jednu pozici, na které se může hráč nacházet.

## Magie

Existují 4 magické atributy. Ty se jednak nachází v prostředí, jednak je má každý hráč. Atributy jsou následující:
- **Zdraví**: Počáteční hodnota je 100. Pokud klesne na 0, hráč umírá.
- **Mana**: Počáteční hodnota je 50. Používá se na přehrávání kouzel. Když mana klesne pod 0, hráč v každém kole ztrácí 10 bodů zdraví.
- **Síla**: Počáteční hodnota je 10. Ovlivňuje sílu kouzel. Efekt kouzla je vypočítán jako `síla_kouzla * síla_hráče`.
- **Váha**: Počáteční hodnota je 10. Určuje, jak moc prostředí ovlivňuje hráče. Efekt prostředí je vypočítán jako `atributy_prostředí * (1 - váha_hráče)`.

Každé políčko v plánu má svůj stav magie. Ten je rozdělený do vrstev pro každého hráče. Každé políčko tedy má 12 atributů - pro každého hráče 4 atributy.

## Kouzla

K tomu, aby hráč mohl přehrát kouzlo, musí jej prvně získat. V prvním kroku hráč musí pomocí *rekordéru* zaznamenat kouzlo z prostředí. Kouzlo se do rekordéru uloží a hráč jej může používat dále. Každý rekordér může obsahovat pouze jedno kouzlo. Použít ho může potom dvěma způsoby:
- **Přehrát**: Hráč může kouzlo přehrát. Tím se ovlivní magické atributy políčka, na kterém se hráč nachází.
- **Syntetizovat**: Hráč může z kouzel, která má nahraná, vytvořit nové kouzlo. K tomu slouží *syntetizátor*.

Kouzla lze použít pouze jednou. Po použití se z rekordéru smažou.

Při použití více kouzel na jednom políčku v jednom kole se jejich efekt násobí.

Efekt kouzla z políčka pomalu vyprchává. Silná kouzla ale dokáží ovlivnit políčko na delší dobu.

## Předměty

Na herním plánu se nachází a průběžně objevují předměty, které můžou hráči sebrat. Tyto předměty slouží nahrávání kouzel a jejich syntetéze.

Ve hře existují následující předměty:
- **Rekordér**: Slouží k zaznamenání kouzla z prostředí a jako vstup/výstup pro syntetizátor.
- **Filtr**: Filtruje atributy kouzla na vstupu.
- **Invertor**: Invertuje atributy kouzla na vstupu.
- **Sčítač**: Sčítá atributy více kouzel na vstupu.

Předměty jsou na plánu a v syntetizátoru reprezentovány následujícími ikonami (ve stejném pořadí jako výše):

![recorder](./src/components/icons/recorder.svg)
![filter](./src/components/icons/filter.svg)
![inverter](./src/components/icons/inverter.svg)
![fuser](./src/components/icons/fuser.svg)

## Syntéza kouzel

Syntéza kouzel probíhá v syntetizátoru. Hráč musí mít k dispozici rekordér s kouzlem, které chce syntetizovat, a předměty, které chce použít.

Průběh syntézy kouzla hráč popisuje pomocí diagramu. Diagram je tvořený uzly, které reprezentují jednotlivé předměty, které aplikují své efekty na kouzlo. Hrany pak popisují, jak se kouzlo transformuje.s

## Průběh hry

Hra probíhá v kolech. V každém kole hráči zadávají své akce, které se zaráz provedou na konci kola. Akce mohou být následující:
- **Pohyb**: Hráč se může pohnout na sousední políčko.
- **Přehrát kouzlo**: Hráč může přehrát kouzlo z rekordéru.
- **Nahrát kouzlo**: Hráč může nahrát kouzlo z prostředí do rekordéru.
- **Syntetizovat kouzlo**: Hráč může syntetizovat kouzlo v syntetizátoru.
- **Sebrat předmět**: Hráč může sebrat předmět, který se nachází na políčku, na kterém se nachází.

Hra končí, když je na živu pouze jeden hráč.
